config/routes.rb
Rails.application.routes.draw do
  resources :leaderboards
  devise_for :users
  resources :lessons
  resources :questions
  resources :quizzes
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Reveal health status on /up that returns 200 if the app boots with no exceptions, otherwise 500.
  # Can be used by load balancers and uptime monitors to verify that the app is live.
  get "up" => "rails/health#show", as: :rails_health_check
  # post 'submit_quiz', to: 'take_quiz#submit'
  post 'take_quiz/:quiz_id/submit', to: 'take_quiz#submit', as: :submit_quiz

  resources :quizzes do
    resources :questions
  end

  resources :lessons do
    resources :comments, only: [:create]
  end

  resources :leaderboards, only: [:index]
  
  resources :take_quiz, only: [:index, :show]
  # Defines the root path route ("/")
  # root "posts#index"
  root to: "lessons#index"
end

app/controllers/quizzes_controller.rb
class QuizzesController < ApplicationController
  before_action :set_quiz, only: %i[ show edit update destroy ]
  before_action :authenticate_user!, only: [:index, :show]
  before_action :ensure_teacher_role

  # GET /quizzes or /quizzes.json
  def index
    @quizzes = Quiz.all
  end

  def ensure_teacher_role
    redirect_to root_path, alert: 'You do not have permission to view this page.' unless current_user&.teacher?
  end

  # GET /quizzes/1 or /quizzes/1.json
  def show
    @quiz = Quiz.find(params[:id])
    @questions = @quiz.questions
  end

  # GET /quizzes/new
  def new
    @quiz = Quiz.new
  end

  # GET /quizzes/1/edit
  def edit
  end

  # POST /quizzes or /quizzes.json
  def create
    @quiz = Quiz.new(quiz_params)

    respond_to do |format|
      if @quiz.save
        format.html { redirect_to quiz_url(@quiz), notice: "Quiz was successfully created." }
        format.json { render :show, status: :created, location: @quiz }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @quiz.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /quizzes/1 or /quizzes/1.json
  def update
    respond_to do |format|
      if @quiz.update(quiz_params)
        format.html { redirect_to quiz_url(@quiz), notice: "Quiz was successfully updated." }
        format.json { render :show, status: :ok, location: @quiz }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @quiz.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /quizzes/1 or /quizzes/1.json
  def destroy
    @quiz.destroy!

    respond_to do |format|
      format.html { redirect_to quizzes_url, notice: "Quiz was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_quiz
      @quiz = Quiz.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    # def quiz_params
    #   params.fetch(:quiz, {})
    # end
    def quiz_params
      params.require(:quiz).permit(:title)
    end
end

app/helpers/quizzes_helper.rb
module QuizzesHelper
end

app/views/quizzes/_form.html.erb
<%= form_with(model: quiz) do |form| %>
  <% if quiz.errors.any? %>
    <div class="error-messages">
      <h2><%= pluralize(quiz.errors.count, "error") %> prohibited this quiz from being saved:</h2>

      <ul>
        <% quiz.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :title %>
    <%= form.text_field :title %>
  </div>

  <!-- Include other form fields here -->

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/quizzes/_quiz.html.erb
<div id="<%= dom_id quiz %>">
</div>

app/views/quizzes/edit.html.erb
<h1>Editing quiz</h1>

<%= render "form", quiz: @quiz %>

<br>

<div>
  <%= link_to "Show this quiz", @quiz %> |
  <%= link_to "Back to quizzes", quizzes_path %>
</div>

app/views/quizzes/index.html.erb
<h1> Create Quizzes </h1>

<% if current_user&.teacher? %>
  <%= link_to "New Quiz", new_quiz_path, class: "btn btn-success mb-3" %>
<% end %>

<table class="table">
  <thead>
    <tr>
      <th>ID</th>
      <th>Title</th>
      <th>Action</th>
    </tr>
  </thead>
  <tbody>
    <% @quizzes.each do |quiz| %>
      <tr>
        <td><%= quiz.id %></td>
        <td><%= quiz.title %></td>
        <td><%= link_to "View", quiz, class: "btn btn-primary" %></td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/quizzes/new.html.erb
<h1>New quiz</h1>

<%= render "form", quiz: @quiz %>

<br>

<div>
  <%= link_to "Back to quizzes", quizzes_path %>
</div>

app/views/quizzes/show.html.erb
<div class="container mt-4">
  <h2 class="mb-3">Quiz Details</h2>

  <table class="table table-bordered">
    <thead>
      <tr>
        <th colspan="4">
          Quiz ID <%= @quiz.id %> - Title: <%= @quiz.title %>
        </th>
      </tr>
    </thead>
    <tbody>
      <% @questions.each_with_index do |question, index| %>
        <tr>
          <td>
            <strong>Question:</strong> <%= index + 1 %>
          </td>
          <td><%= question.title %></td>
          <td>
            <%= link_to 'View Question', question_path(question), class: "btn btn-info btn-sm" %>
          </td>
        </tr>
      <% end %>
    </tbody>
  </table>

  <div class="row">
    <div class="col-md-6">
      <%= link_to 'Add Question', new_quiz_question_path(@quiz), class: "btn btn-primary" %>
    </div>
    <div class="col-md-6 text-end">
      <%= link_to "Edit this quiz", edit_quiz_path(@quiz), class: "btn btn-secondary" %> |
      <%= link_to "Back to quizzes", quizzes_path, class: "btn btn-secondary" %>
    </div>
  </div>

  <div class="text-center mt-4">
    <%= button_to "Destroy this quiz", @quiz, method: :delete, data: { confirm: "Are you sure?" }, class: "btn btn-danger" %>
  </div>
</div>